org.optaplanner.core.impl.score.buildin.simple

## Class SimpleScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<SimpleScore>
  - - org.optaplanner.core.impl.score.buildin.simple.SimpleScoreDefinition

- All Implemented Interfaces:
    Serializable, ScoreDefinition<SimpleScore>

      public class SimpleScoreDefinition
      extends AbstractScoreDefinition<SimpleScore>

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleScoreDefinition()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SimpleScore` | `buildOptimisticBound(InitializingScoreTrend initializingScoreTrend, SimpleScore score)` Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `SimpleScore` | `buildPessimisticBound(InitializingScoreTrend initializingScoreTrend, SimpleScore score)` Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `SimpleScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)` Used by `DroolsScoreDirector`.
    `SimpleScoreInliner` | `buildScoreInliner(boolean constraintMatchEnabled)` Used by `BavetConstraintFactory`
    `SimpleScore` | `fromLevelNumbers(int initScore, Number[] levelNumbers)` The opposite of `Score.toLevelNumbers()`.
    `int` | `getLevelsSize()` Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition.
    `Class<SimpleScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation.
    `SimpleScore` | `getZeroScore()` The score that represents zero.
    `SimpleScore` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `formatScore, getInitLabel, getLevelLabels, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### SimpleScoreDefinition

          public SimpleScoreDefinition()

  - ### Method Detail

    - #### getLevelsSize

          public int getLevelsSize()

      Description copied from interface: `ScoreDefinition`
      Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition. For example: returns 2 on `HardSoftScoreDefinition`.
      Specified by:
        `getLevelsSize` in interface `ScoreDefinition<SimpleScore>`
      Overrides:
        `getLevelsSize` in class `AbstractScoreDefinition<SimpleScore>`
      Returns:
        at least 1

    - #### getScoreClass

          public Class<SimpleScore> getScoreClass()

      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public SimpleScore getZeroScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### parseScore

          public SimpleScore parseScore(String scoreString)

      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public SimpleScore fromLevelNumbers(int initScore,
                                              Number[] levelNumbers)

      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### buildScoreInliner

          public SimpleScoreInliner buildScoreInliner(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public SimpleScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public SimpleScore buildOptimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                  SimpleScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public SimpleScore buildPessimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                   SimpleScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

Copyright © 2006–2019 JBoss by Red Hat. All rights reserved.